package kd.bos.newdevportal.table;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.db.DBRoute;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.form.events.AfterDoOperationEventArgs;

import kd.bos.list.plugin.AbstractListPlugin;
import kd.bos.newdevportal.table.DesignerTable;
import kd.bos.newdevportal.table.TableManagerListPlugin;
import java.util.Collections;
import java.util.Iterator;
import java.util.Map;
import kd.bos.dataentity.utils.StringUtils;
import kd.bos.db.DB;
import kd.bos.db.DBRoute;
import kd.bos.entity.EntityMetadataCache;
import kd.bos.entity.datamodel.ListSelectedRow;
import kd.bos.entity.datamodel.ListSelectedRowCollection;
import kd.bos.form.control.events.ItemClickEvent;
import kd.bos.list.BillList;
import kd.bos.metadata.dao.MetadataDao;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.scm.bid.formplugin.report.biddetailquery.QingFiledContent;
import sys.sc.opplugin.utils.DatFileCreatUtils;

import java.util.*;
import java.util.stream.Collectors;


/**
 * @author cjz
 * @date 2024/9/18 11:30
 * @description:数据表基础资料，选择数据表带出数据表信息
 */
 public class TableDataBasicPlugin extends AbstractListPlugin {
    //数据表基础资料标识
    private static String nckd_tabledatabasic="nckd_tabledatabasic";

    //选择数据表基础资料后，将数据表信息带出
    public void propertyChanged(PropertyChangedArgs e){
        super.beforePropertyChanged(e);
        String name=e.getProperty().getName();
        if (nckd_tabledatabasic.equals(name)) {
            //先清空表字段分录
            this.getModel().deleteEntryData("nckd_tableentry");
            //获取单据模型
            DynamicObject data=this.getModel().getDataEntity(true);
            //获取数据表基础资料
            DynamicObject tabledatabasic=data.getDynamicObject(nckd_tabledatabasic);
            //业务应用编码
            String bizappnumber=tabledatabasic.getString("nckd_bizapp.number");
            //表命名字段赋值
            this.getModel().setValue("number",tabledatabasic.getString("tablename"));
            //业务编码赋值
            this.getModel().setValue("nckd_biazppnum",bizappnumber);
            //表名称
            this.getModel().setValue("name",tabledatabasic.getString("nckd_entity.name"));
            DBTableProviderNew provider =new DBTableProviderNew();
            QFilter filtercol=new QFilter("number",QCP.equals,bizappnumber);
            //业务云
            DynamicObject bizappcloudDy=BusinessDataServiceHelper
                    .loadSingle("bos_devportal_bizapp","id,bizcloud.number",new QFilter[]{filtercol});
            //业务云编码
            String bizcloudnum=bizappcloudDy.getString("bizcloud.number");
            //设置为sys系统服务云库
            provider.setRoute(DBRoute.of(bizcloudnum));

            Map<String, DesignerTable> tableMap =provider
                    .getTableInfo_youhua(Collections.singletonList(tabledatabasic.getString("tablename")),
                            Collections.singletonList(tabledatabasic.getString("id")));
            for (Map.Entry<String, DesignerTable> table : tableMap.entrySet()) {
                //表名
                String tablename = table.getKey();
                DesignerTable designerTable = table.getValue();
                String comment = designerTable.getName();
                //获取表字段
                Iterator fields = designerTable.getCols().iterator();
                while(fields.hasNext()) {
                    DesignerColumn col = (DesignerColumn)fields.next();
                    String f_fieldkey = col.getCode();//字段标识
                    String f_fieldname = col.getName();//字段名称
                    //表字段新增分录行
                    int rowIndex = this.getModel().createNewEntryRow("nckd_tableentry");
                    //字段标识
                    this.getModel().setValue("nckd_entrycode",f_fieldkey,rowIndex);
                    //字段名
                    this.getModel().setValue("nckd_entryname",f_fieldname,rowIndex);
                    this.getModel().setValue("nckd_isable",1,rowIndex);
                }
            }
        }
    }
}
